#ifndef _RTP_SESSION_HH_
#define _RTP_SESSION_HH_

#include <unistd.h>
#include "sys_msg.hh"

class RTP_Session
{
private:
  pid_t               rtpd_pid;
  SYS_Message_Queue*  pmsg_queueS;
  SYS_Message_Queue*  pmsg_queueR;
  char                reply_buffer[256];
  RTP_Session(pid_t,int,int);
  ~RTP_Session();
public:
  static RTP_Session* 
    Open_RTP_Session(
		     int,                  // send queue
		     int,                  // receive queue
		     unsigned short,       // port
		     int,                  // rx buffer size
		     int,                  // tx buffer size
		     int);                 // mode 

  static void Close_RTP_Session(RTP_Session*);

  int AddMember(char*,                     // hostname
		unsigned short);           // port

  int ReadMIB(const char*,char*);          // direct access to rtp mib on read
  int WriteMIB(const char*,const char*);   // direct access to rtp mib on write

  int SetAsync();

  int GetSSRCCount();         

  int Send(void*,                          // buffer address 
	   unsigned int,                   // length of data
	   unsigned int);                  // timestamp

  int ReceiveSync(int,                     // mode 
		  unsigned int*,           // requested ssrc | returned ssrc
		  void*,                   // buffer address
		  unsigned int);           // size of buffer  
};

#endif


